import pyodbc 
import csv

server = 'tcp:apa.di.unipi.it' 
database = 'Foodmart' 
username = 'lbi' 
password = 'pisa' 
cnxn = pyodbc.connect('DRIVER={ODBC Driver 17 for SQL Server};SERVER='+server+';DATABASE='+database+';UID='+username+';PWD='+ password)


timeid_98 = set()
timeid_97 = set()
cursor = cnxn.cursor()
cursor.execute("SELECT *a FROM time_by_day;")
row = cursor.fetchone() 
while row:
    if(row.the_year == 1997):
        timeid_97.add(row.time_id)
    elif(row.the_year == 1998):
        timeid_98.add(row.time_id)
    row = cursor.fetchone()
cursor.close()

customer_f = set()
cursor = cnxn.cursor()
cursor.execute("SELECT * FROM customer;") 
row = cursor.fetchone() 
while row:
    if row.gender == "F":
        customer_f.add(row.customer_id)
    row = cursor.fetchone()
cursor.close()

low_fat_products = set()
cursor = cnxn.cursor()
cursor.execute("SELECT * FROM product;") 
row = cursor.fetchone() 
while row:
    if row.low_fat == 1:
        low_fat_products.add(row.product_id)
    row = cursor.fetchone() 
cursor.close()

product_98 = dict()
product_97 = dict()
cursor = cnxn.cursor()
cursor.execute("SELECT * FROM sales_fact;") 
row = cursor.fetchone() 
p = set()
while row:
    if row.product_id in low_fat_products and row.customer_id in customer_f:
        if row.time_id in timeid_97:
            if row.product_id not in product_97:
                product_97[row.product_id] = 0
            product_97[row.product_id] += row.store_sales
        elif row.time_id in timeid_98:
            if row.product_id not in product_98:
                product_98[row.product_id] = 0
            product_98[row.product_id] += row.store_sales
    row=cursor.fetchone()
cursor.close()

product_delta = dict()
total_delta = 0
for product in product_98:
    if product in product_97:
        s_98 = product_98[product]
        s_97 = product_97[product]
        delta = s_98 - s_97
        product_delta[product] = delta
        total_delta += delta

mean_delta = total_delta/len(product_delta)

sorted_tuples = sorted(product_delta.items(), key=lambda x: x[1], reverse=True)
    
with open('lbi02062019.csv', 'w', newline='') as csvfile:
    fieldnames = ["product_id", "delta","mean_delta"]
    writer = csv.DictWriter(csvfile, fieldnames=fieldnames)
    writer.writeheader()
    for t in sorted_tuples:
        product = t[0]
        delta = t[1]
        if delta > mean_delta:
            writer.writerow({"product_id": product, "delta": delta, "mean_delta":mean_delta})
